import java.awt.event.*;

import javax.swing.*;
import javax.media.opengl.GL;
import javax.media.opengl.GL2ES1;
import javax.media.opengl.GL2;
import javax.media.opengl.GLAutoDrawable;
import javax.media.opengl.GLEventListener;
import javax.media.opengl.awt.AWTGLAutoDrawable;
import javax.media.opengl.awt.GLCanvas;
import javax.media.opengl.awt.GLJPanel;
import com.jogamp.opengl.util.Animator;

// +-------------------------+
// |       View3D class      |
// +-------------------------+
public class Canvas3D extends GLCanvas implements GLEventListener {
	Test3D root;
	Animator animator;
//========================== 

	float rotz =0.0f;

// +------------------------+
// |     RXgN^[   |
// +------------------------+
	public Canvas3D(Test3D frame) {
		root = frame;
		addGLEventListener(this); // Xi[Zbg

		setBounds(0,0,640,480);

		animator = new Animator(this);
		frame.addWindowListener(
			new WindowAdapter() {
				public void windowClosing(WindowEvent e) {
// AWT event queue m Animator.stop() ĂԂߕʃXbhŎsB
					new Thread(
						new Runnable() {
							public void run() {
								animator.stop();
								System.exit(0);
							}
						}
					).start();
				}
			}
		);
		animator.start();
	}

// GLEventListener
	public void init(GLAutoDrawable drawable) {
		GL2 gl = drawable.getGL().getGL2();
		gl.setSwapInterval(1);
		if (drawable instanceof AWTGLAutoDrawable) {
			AWTGLAutoDrawable awtDrawable = (AWTGLAutoDrawable) drawable;
		}
	}
 
// GLEventListener
	public void reshape(GLAutoDrawable drawable, int x, int y, int width, int height) {
		GL2 gl = drawable.getGL().getGL2();
		 
		float h = (float)height / (float)width;
		 
		gl.glMatrixMode(GL2.GL_PROJECTION);
		 
		System.err.println("GL_VENDOR: " + gl.glGetString(GL2.GL_VENDOR));
		System.err.println("GL_RENDERER: " + gl.glGetString(GL2.GL_RENDERER));
		System.err.println("GL_VERSION: " + gl.glGetString(GL2.GL_VERSION));
		gl.glLoadIdentity();
		gl.glFrustum(-1.0f, 1.0f, -h, h, 5.0f, 60.0f);
	}
	 
	public void dispose(GLAutoDrawable drawable) {
		System.out.println("test.dispose: "+drawable);
	}

// GLEventListener
	public void display(GLAutoDrawable drawable) {
		
		GL2 gl = drawable.getGL().getGL2();
		gl.glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
		gl.glClear(GL2.GL_COLOR_BUFFER_BIT | GL2.GL_DEPTH_BUFFER_BIT);

// `
		gl.glMatrixMode(GL2.GL_MODELVIEW);
		gl.glLoadIdentity();
		gl.glTranslatef(0.0f, 0.0f, -20.0f);
		gl.glRotatef(rotz, 0.0f, 0.0f, 1.0f);
		rotz += 5;

		gl.glColor4f(1.0f, 1.0f, 1.0f, 0.0f);
		gl.glBegin(gl.GL_LINES);
			gl.glVertex3f(1.0f, 1.0f, 0.0f);
			gl.glVertex3f(1.0f, -1.0f, 0.0f);
			gl.glVertex3f(-1.0f, 1.0f, 0.0f);
			gl.glVertex3f(1.0f, 1.0f, 0.0f);
			gl.glVertex3f(-1.0f, -1.0f, 0.0f);
			gl.glVertex3f(-1.0f, 1.0f, 0.0f);
			gl.glVertex3f(-1.0f, -1.0f, 0.0f);
			gl.glVertex3f(1.0f, -1.0f, 0.0f);
		gl.glEnd();
	}
	 
// GLEventListener
	public void displayChanged(GLAutoDrawable drawable, boolean modeChanged, boolean deviceChanged) {
	}

} // View3D
